
var arivoc_btn_play_teacher_all = null;
var arivoc_btn_pause_play = null;
var arivoc_btn_play_single = null;
var arivoc_btn_deduct_word = null;
var arivoc_select_play_sentence_wait = null;
var arivoc_select_play_sentence_wait_ctime = null;
var arivoc_audio_playId = null;
var arivoc_course_txt_divId = null;
var arivoc_course_cnTxt_divId = null;
var arivoc_log_divId = null;
var arivoc_course_impword_show = null;

var arivoc_course = null;
var arivoc_course_sentence_clicked = false;
var arivoc_course_sentence_wait = 0;
var arivoc_cur_mode = null;
var arivoc_impword_show = false;

var arivoc_course_save_url = "";

var arivoc_course_restartid;

function arivoc_course_getCourseXMLOffLine(rootpath, xmlpath, impStr) {
	
	arivoc_course = new Arivoc_Course_Read();
	arivoc_course.root_path = "file://"+dataRoot()+"\course";
	arivoc_course.offlineRoot = rootpath;
	arivoc_course.online = false;
//	$("#" + arivoc_btn_select_model).val(0);
	$(".playSentence_Wait").html("关");
	$("#playSentence_Wait_Select li").removeClass("on");
	$("#playSentence_Wait_Select li:first").addClass("on");
	$("#Arivoc_Course_Model_BTN .course_Model").html("领读模式");
	$("#course_Model_Select li").removeClass("on");
	$("#course_Model_Select li:first").addClass("on");
	
	var urlStr = xmlpath;
	
	$.ajax({
		type : "get",
		url : urlStr,
		dataType : "xml",
		timeout : 1000,
		cache : false,
		success : function(data) {
			getImpWord(data);
		},
		error: function(a, b, c) {}
	});
	
	function getImpWord(data) {
		$.ajax({
			url: impStr,
			type: "get",
			dataType: "json",
			timeout : 1000,
			cache : false,
			success: function(returndata) {
				if (returndata.isBuckle == 1) {
					arivoc_course.hasDeduct = true;
					arivoc_course.impWord = returndata.sentence;
				}
				arivoc_course_parseCourseXML(data);
			},
			error: function(XMLHttpRequest, textStatus, errorThrown) {
				arivoc_course_parseCourseXML(data);
			}
		});
	}
}

function arivoc_course_getCourseXMLOnLine(urlStr, impStr, saveStr, lessonId) {
	
	arivoc_course_save_url = saveStr;
	
	arivoc_course = new Arivoc_Course_Read();
	arivoc_course.root_path = "http://course.kouyu100.com/course";
	arivoc_course.online = true;
	arivoc_course.lessonId = lessonId;
//	$("#" + arivoc_btn_select_model).val(0);
	$(".playSentence_Wait").html("关");
	$("#playSentence_Wait_Select li").removeClass("on");
	$("#playSentence_Wait_Select li:first").addClass("on");
	$("#Arivoc_Course_Model_BTN .course_Model").html("领读模式");
	$("#course_Model_Select li").removeClass("on");
	$("#course_Model_Select li:first").addClass("on");
	
	$.ajax({
		url: urlStr,
		type: "get",
		contentType: "application/jsonp; charset=utf-8",
		dataType: "jsonp",
		jsonp: "callback",
		jsonpCallback: "lessonXMLBack",
		data: {
			lessonId: lessonId
		},
		success: function(returndata) {
			if (returndata.result == 0) {
				getImpWord(returndata.xml);
//				arivoc_course_parseCourseXML(returndata.xml);
			} else {
//				alert("获取课内容失败！");
			}
		},
		error: function(XMLHttpRequest, textStatus, errorThrown) {
//			alert("获取课内容失败！");
		}
	});
	
	function getImpWord(xml) {
		$.ajax({
			url: impStr,
			type: "get",
			contentType: "application/jsonp; charset=utf-8",
			dataType: "jsonp",
			jsonp: "callback",
			jsonpCallback: "resourceBuckleBack",
			data: {
				lessId: lessonId
			},
			success: function(returndata) {
				if (returndata.result == 0 && returndata.isBuckle == 1) {
					arivoc_course.hasDeduct = true;
					arivoc_course.impWord = returndata.sentence;
				} 
				arivoc_course_parseCourseXML(xml);
			},
			error: function(XMLHttpRequest, textStatus, errorThrown) {
				arivoc_course_parseCourseXML(xml);
			}
		});
	}
	
}

function arivoc_course_parseCourseXML(data) {
	
	arivoc_course_read_reset();
	
	if($("#"+arivoc_btn_deduct_word).prop("checked")){
		arivoc_course.deduct_word = true;
	}else{
		arivoc_course.deduct_word = false;		
	}
	
	arivoc_course.data = data;
	
	$(data).find("sentence").each(function(i) {

		var sentence = new Arivoc_Course_Read_Sentence();
		sentence.sid = $(this).children("sid").text();
		sentence.role = $(this).children("role").text();
		sentence.orginText = $(this).children("text").text();
		sentence.text = arivoc_course_read_getText(sentence.orginText);
		sentence.cnText = $(this).children("cnText").text();
		sentence.audioPath = $(this).children("audioPath").text();
		sentence.impWord = $(this).children("impWord").text();
		sentence.buckleWord = getImpWordBySid(sentence.sid);
		arivoc_course.sentences.push(sentence);

		if (arivoc_course.display == null) {
			var rr = sentence.role.charAt(0);
			if (rr == 'A') {
				arivoc_course.display = arivoc_course.PARAGRAPH;
			} else {
				arivoc_course.display = arivoc_course.ROLEPARAGRAPH;
			}
		}

	});

	arivoc_course.draw();
	arivoc_course.draw_background(0);
	arivoc_course.show_cnText(0);
	
	
}

function Arivoc_Course_Read() {
	this.offlineRoot = null;
	this.lessonId = -1;
	this.curIndex = -1;
	this.display = null;
	this.root_path;
	this.sentences = new Array();
	this.online = false;
	this.data;
	this.deduct_word = false;
	this.hasDeduct = false; // 是否有手动扣词
	this.isBuckle = false; // true为使用手动扣词 false为使用自动扣词
	this.impWord = null;
	this.draw = function() {
		if (this.display == this.ROLEPARAGRAPH) {
			arivoc_course_read_draw_roleparagraph(this);
		}else if (this.display == this.PARAGRAPH) {
			arivoc_course_read_draw_paragraph(this);
		}
		
		$(".course-impword").on("click", function() {
			if ($(this).hasClass("impShow")) {
				$(this).removeClass("impShow");
				if ($(this).parent().hasClass("current-sentence")) {
					$(this).css({"color" : "#768999"});
				} else {
					$(this).css({"color" : "#334237"});
				}
			} else {
				$(this).addClass("impShow");
				$(this).css({"color" : "#FFFFFF"});
			}
			
			if ($(".course-impword").length == $(".course-impword.impShow").length) {
				$("#" + arivoc_course_impword_show + " input").prop("checked", true);
			} else {
				$("#" + arivoc_course_impword_show + " input").prop("checked", false);
			}
		});
		
	}

	this.draw_background = function(indexId) {
		for (var i = 0; i < this.sentences.length; i++) {
			
			var spans = $("#sentence_text_" + i).children();
			$("#sentence_text_" + i).css({"background" : ""});
			for(var j=0; j < spans.length; j++){
				if (!arivoc_impword_show && $(spans[j]).hasClass("course-impword")) {
					if ($(spans[j]).hasClass("impShow")) {
						$(spans[j]).css({"color" : "#FFFFFF"});
					} else {
						$(spans[j]).css({"color" : "#334237"});
					}
				}
			}
		}

		var spans = $("#sentence_text_" + indexId).children();
		$(".current-sentence").removeClass("current-sentence");
		$("#sentence_text_" + indexId).addClass("current-sentence");
		$("#sentence_text_" + indexId).css({"background" : "#768999"});
		for(var j=0; j < spans.length; j++){
			if (!arivoc_impword_show && $(spans[j]).hasClass("course-impword")) {
				if ($(spans[j]).hasClass("impShow")) {
					$(spans[j]).css({"color" : "#FFFFFF"});
				} else {
					$(spans[j]).css({"color" : "#768999"});
				}
			}
		}
		
		if (this.display == this.ROLEPARAGRAPH) {
			var jump = ($("#sentence_text_" + indexId).attr("row_num") - 2)	* $("#sentence_text_" + indexId).height();
			if (jump < 0) {	jump = 0; }
			$("#" + arivoc_course_txt_divId).scrollTop(jump);
		}
	}

	this.show_cnText = function(indexId) {
		var contentCNText = $("#" + arivoc_course_cnTxt_divId);
		contentCNText.html("<span style='-moz-user-select:none;width:400px;display:inline-block;background-color:#7aab85;color:#FFF;text-align:center'>" + this.sentences[indexId].cnText + "</span>");
	}

	this.play_teacher = function(indexId) {
		stopAllAudio("course");
		
		var audioPath = arivoc_course.root_path + "/" +this.sentences[indexId].audioPath;
		var teacher = $("#" + arivoc_audio_playId)[0];
		teacher.src = audioPath;
		teacher.play();
	}
	
	this.reset = arivoc_course_read_reset;

	this.arivoc_mode_playteacherall = "play_teacher_all";
	this.arivoc_mode_playsingle = "play_single";
	this.ROLEPARAGRAPH = "roleparagraph";
	this.PARAGRAPH = "paragraph";
}

function arivoc_course_read_reset(){
	
	
	var audio = $("#" + arivoc_audio_playId)[0];
	audio.pause();
	audio.src = "";
	
	$("#" + arivoc_btn_play_teacher_all).css({"opacity" : "0.5"});
	$("#" + arivoc_btn_play_single).css({"opacity" : "0.5"});
	$("#" + arivoc_btn_pause_play).css({"opacity" : "0.5"});
	$("#" + arivoc_btn_pause_play).html("暂停播放");	
	$("#" + arivoc_course_impword_show).css({"opacity" : "0"});
	$("#" + arivoc_course_impword_show + " input").prop("checked", false);
	showCourseImpword(false);

	//$("#" + arivoc_btn_deduct_word).prop("checked",false);

	clearTimeout(arivoc_select_play_sentence_wait_ctime);
	

}

function arivoc_course_read_draw_background(indexId) {
	if (arivoc_course_sentence_clicked) {
		$("#" + arivoc_audio_playId)[0].onended = null;
		arivoc_course.draw_background(indexId);
		arivoc_course.play_teacher(indexId);
		arivoc_course.show_cnText(indexId);
	}
}

function arivoc_course_read_draw_roleparagraph(course) {

	var contentText = $("#" + arivoc_course_txt_divId);
	contentText.empty();
	contentText.scrollTop(0);
	var role = null;
	var draw_str = "";
	var draw_rows = 0;
	for (var i = 0; i < course.sentences.length; i++) {
		var sentence = course.sentences[i];
		if (role != sentence.role) {
			if (role != null) {	draw_str += "</div>"; }
			draw_rows++;
			role = sentence.role;
			draw_str += "<div><span style='-moz-user-select:none;color:#95c387;display:inline-block;padding-left:20px;padding-right:5px;'>"	+ sentence.role + " : </span>";
		}
		draw_str += "<span id='sentence_text_"+ i + "' row_num=" + draw_rows + " style='-moz-user-select:none;color:#fff;padding-left:10px;' onclick='arivoc_course_read_draw_background(" + i + ")'>";
		var words = sentence.text.split(" ");
		var impWords;
		if (arivoc_course.isBuckle) {
			impWords = sentence.buckleWord.split(" ");
		} else {
			impWords = sentence.impWord.split(" ");
		}
		for(var j=0; j<words.length; j++){
			if(words[j]==""){
				continue;
			}
			
			if(course.deduct_word && impWords.indexOf(words[j])>=0){
//				var st = "_";
//				for (var z = 0; z < words[j].length; z++) {
//					st += "_";
//				}
				draw_str +=  "<span class='course-impword' style='display:inline-block;margin-left:3px;margin-right:3px;border: 0px solid red; border-bottom: 1px solid #FFFFFF; color: #334237'>"+ /*st*/words[j] +"</span>";
			}else{				
				draw_str +=  "<span style='display:inline-block;margin-left:3px;margin-right:3px;border: 0px solid red;'>"+ words[j] +"</span>";
			}
			
		}
		draw_str += "</span>";
	}
	draw_str += "</div>";
	contentText.append(draw_str);

	draw_str = "";
	for (var i = 0; i < draw_rows; i++) {
		draw_str += "<div style='height:22px'></div>";
	}
	contentText.append(draw_str);
}

function arivoc_course_read_draw_paragraph(course) {

	var contentText = $("#" + arivoc_course_txt_divId);
	contentText.empty();
	contentText.scrollTop(0);
	var role = null;
	var draw_str = "";
	var draw_rows = 0;
	
	draw_str += "<div style='height:22px;'>";
	for (var i = 0; i < course.sentences.length; i++) {
		var sentence = course.sentences[i];		
		draw_rows++;
		draw_str += "<span id='sentence_text_"+ i + "' row_num=" + draw_rows + " style='-moz-user-select:none;color:#fff;border: 0px solid blue;";
		if(i==0){
			draw_str += "margin-left:20px;";
		}
		draw_str += "padding-left:5px;padding-right:5px;' onclick='arivoc_course_read_draw_background(" + i + ")'>";
		
		var words = sentence.text.split(" ");
		var impWords;
		if (arivoc_course.isBuckle) {
			impWords = sentence.buckleWord.split(" ");
		} else {
			impWords = sentence.impWord.split(" ");
		}
		
		for(var j=0; j<words.length; j++){
			if(words[j]==""){
				continue;
			}			
			
			if(course.deduct_word && impWords.indexOf(words[j])>=0){
//				var st = "_";
//				for (var z = 0; z < words[j].length; z++) {
//					st += "_";
//				}
				draw_str +=  "<span class='course-impword' style='display:inline-block;margin-left:3px;margin-right:3px;border: 0px solid red; border-bottom: 1px solid #FFFFFF; color: #334237'>"+ /*st*/words[j] +"</span>";
			}else{				
				draw_str +=  "<span style='display:inline-block;margin-left:3px;margin-right:3px;border: 0px solid red;'>"+ words[j] +"</span>";
			}
		}
		draw_str += "</span>";
	}
	draw_str += "</div>";
	contentText.append(draw_str);

	draw_str = "";
	for (var i = 0; i < draw_rows; i++) {
		draw_str += "<div style='height:22px'></div>";
	}
	contentText.append(draw_str);
}

function Arivoc_Course_Read_Sentence() {
	this.sid;
	this.role;
	this.part;
	this.text;
	this.orginText;
	this.cnText;
	this.audioPath;
	this.syllables;
	this.impWord;
	this.buckleWord;
}

function arivoc_course_read_playTeacherOnEnded() {
	if (!arivoc_course_sentence_clicked) {
		setTimeout("arivoc_course_read_wait_time()", 0);
	}
}

function arivoc_course_read_wait_time() {
	if (arivoc_course_sentence_wait > 0) {
		arivoc_course_read_sleep(arivoc_course_sentence_wait, null,"arivoc_course_read_playNextTeacher");
	} else {
		arivoc_course_read_playNextTeacher();
	}
}

function arivoc_course_read_playNextTeacher() {

	arivoc_course.curIndex++;
	if (arivoc_course.curIndex < arivoc_course.sentences.length) {
		arivoc_course.draw_background(arivoc_course.curIndex);
		arivoc_course.play_teacher(arivoc_course.curIndex);
		arivoc_course.show_cnText(arivoc_course.curIndex);
	} else {
		$("#" + arivoc_audio_playId)[0].onended = null;
		arivoc_course.draw_background(0);
		arivoc_course.show_cnText(0);
		if (arivoc_cur_mode == arivoc_course.arivoc_mode_playteacherall) {
			$("#" + arivoc_btn_play_teacher_all).css({"opacity" : "0.5"});
			if (!arivoc_course.deduct_word) {
				arivoc_course_restartid = setTimeout(arivoc_course_read_playTeacherAll, 2000);
			}
		}
		
	}
}

function arivoc_course_read_playTeacherAll() {
	clearTimeout(arivoc_course_restartid);
	$("#" + arivoc_btn_play_teacher_all).css({"opacity" : "1"});
	$("#" + arivoc_btn_play_single).css({"opacity" : "0.5"});
	$("#" + arivoc_btn_pause_play).css({"opacity" : "0.5"});
	arivoc_cur_mode = arivoc_course.arivoc_mode_playteacherall;
	arivoc_course_sentence_clicked = false;
	arivoc_course.curIndex = -1;
	$("#" + arivoc_audio_playId)[0].onended = arivoc_course_read_playTeacherOnEnded;
	arivoc_course_read_playNextTeacher();
}

function arivoc_course_read_pausePlayTeacher() {
	clearTimeout(arivoc_course_restartid);
	var audio = $("#" + arivoc_audio_playId)[0];
	var btn = $("#" + arivoc_btn_pause_play);
	if (audio.paused && btn.html() == "继续播放") {
		audio.currentTime = 0;
		audio.play();
		btn.html("暂停播放");
		btn.css({"opacity" : "0.5"});
		
		if (arivoc_cur_mode == arivoc_course.arivoc_mode_playteacherall) {
			$("#" + arivoc_btn_play_teacher_all).css({"opacity" : "1"});
		} else {
			$("#" + arivoc_btn_play_single).css({"opacity" : "1"});
		}
		
	} else if (!arivoc_course_sentence_clicked || !audio.ended) {
		audio.pause();
		btn.html("继续播放");
		btn.css({"opacity" : "1"});
		clearTimeout(arivoc_select_play_sentence_wait_ctime);
		$("#" + arivoc_btn_play_teacher_all).css({"opacity" : "0.5"});
		$("#" + arivoc_btn_play_single).css({"opacity" : "0.5"});
	}
}

function arivoc_course_read_onOpenSentenceClicked() {
	clearTimeout(arivoc_select_play_sentence_wait_ctime);
	clearTimeout(arivoc_course_restartid);
	var btn = $("#" + arivoc_btn_play_single);
	if (arivoc_course_sentence_clicked) {
		arivoc_course_sentence_clicked = false;
		btn.css({"opacity" : "0.5"});
	} else {
		arivoc_course_sentence_clicked = true;
		btn.css({"opacity" : "1"});
	}
	arivoc_cur_mode = arivoc_course.arivoc_mode_playsingle;

	$("#" + arivoc_audio_playId)[0].pause();
	$("#" + arivoc_btn_play_teacher_all).css({"opacity" : "0.5"});
	$("#" + arivoc_btn_pause_play).css({"opacity" : "0.5"});
	
	$("#sentence_text_0").trigger("click");
}

function arivoc_course_read_onOpenSentenceWait(type,obj) {
	arivoc_course_sentence_wait = parseInt(type);
	$("#playSentence_Wait_Select li").removeClass("on");
	$(obj).addClass("on");
	var html = "关";
	if(type ==3000){
		html = "开";
	}
	$(".playSentence_Wait").html(html);
	
	$("#playSentence_Wait_Select").hide();
}

function arivoc_course_read_onDeductWord(type,obj){
	
//	arivoc_course.reset();
//	$("#course_Model_Select li").removeClass("on");
//	$(obj).addClass("on");
	if (type == 1) {
		
		$("body").wordDeduct(arivoc_course, function(result) {
			arivoc_course.reset();
			$("#course_Model_Select li").removeClass("on");
			$(obj).addClass("on");
			switch (result) {
				case "auto":
				arivoc_course.isBuckle = false;
				break;
				case "hand":
				arivoc_course.isBuckle = true;
				break;
				default:
				arivoc_course.hasDeduct = true;
				arivoc_course.isBuckle = true;
				arivoc_course.impWord = result;
				$.each(arivoc_course.sentences, function(i, s) {
					s.buckleWord = getImpWordBySid(s.sid);
				});
				break;
			}
			arivoc_course.deduct_word = true;
			arivoc_course.draw();
			arivoc_course.draw_background(0);
			arivoc_course.show_cnText(0);
			$("#Arivoc_Course_Model_BTN .course_Model").html("扣词模式");
			$("#" + arivoc_course_impword_show).css({"opacity" : "1"});
		});
		
		
//		arivoc_course.deduct_word = true;
//		arivoc_course.draw();
//		arivoc_course.draw_background(0);
//		arivoc_course.show_cnText(0);
//		$("#Arivoc_Course_Model_BTN .course_Model").html("扣词模式");
//		$("#" + arivoc_course_impword_show).css({"opacity" : "1"});
	} else {
		arivoc_course.reset();
		$("#course_Model_Select li").removeClass("on");
		$(obj).addClass("on");
		arivoc_course.deduct_word = false;
		arivoc_course.draw();
		arivoc_course.draw_background(0);
		arivoc_course.show_cnText(0);
		$("#Arivoc_Course_Model_BTN .course_Model").html("领读模式");
		$("#" + arivoc_course_impword_show).css({"opacity" : "0"});
		$("#" + arivoc_course_impword_show + " input").prop("checked", false);
		showCourseImpword(false);
	}
	$("#course_Model_Select").hide();
//	if($("#"+arivoc_btn_deduct_word).prop("checked")){
//		arivoc_course.deduct_word = true;
//		arivoc_course.draw();
//		arivoc_course.draw_background(0);
//		arivoc_course.show_cnText(0);
//	}else{
//		arivoc_course.deduct_word = false;
//		arivoc_course.draw();
//		arivoc_course.draw_background(0);
//		arivoc_course.show_cnText(0);
//	}
	
}

function arivoc_course_read_getText(txt) {
	var txt2 = "";
	var index1 = 0;
	var index2 = -1;
	for (var i = 0; i < txt.length; i++) {
		var c = txt.charAt(i);
		if (c == '{' && index2 == -1) {
			index2 = i;
		}
		if (c == '}' && index2 >= 0 && index2 > index1) {
			txt2 += txt.substring(index1, index2);
			index1 = i + 1;
			index2 = -1;
		}
	}

	if (index1 == 0 && index2 == -1) {
		txt2 = txt;
	} else if (index1 > 0 && index1 < txt.length) {
		txt2 += txt.substring(index1, txt.length);
	}
	return txt2;
}

function arivoc_course_read_sleep(numberMillis, exitTime, callfunction) {
	var now = new Date();
	exitTime = exitTime || (now.getTime() + numberMillis);

	if (now.getTime() > exitTime) {
		arivoc_select_play_sentence_wait_ctime = setTimeout(callfunction, 0);
	} else {
		arivoc_select_play_sentence_wait_ctime = setTimeout("arivoc_course_read_sleep(" + numberMillis + "," + exitTime	+ "," + callfunction + ")", 200);
	}
}

function getImpWordBySid(sid) {
	if (!arivoc_course || !arivoc_course.impWord) {
		return "";
	}
	for (var i = 0; i < arivoc_course.impWord.length; i++) {
		if (arivoc_course.impWord[i].sid == sid) {
			return arivoc_course.impWord[i].impWord;
		}
	}
	return "";
}

function showCourseImpword(isShow) {
	arivoc_impword_show = isShow;
	if (arivoc_impword_show) {
		$(".course-impword").css("color", "#FFFFFF");
		$(".course-impword").addClass("impShow");
	} else {
		$(".course-impword").css("color", "#334237");
		$(".current-sentence .course-impword").css("color", "#768999");
		$(".course-impword").removeClass("impShow");
	}
}

function log(msg) {
	var logger = $("#" + arivoc_log_divId);
	logger.html(msg + "</br>" + logger.html());
}

function cleanText(arr) {
	var returnarr = new Array();
	var points = [",", ".", "?", "!", ";", "'", '"', ":"];
	for (var i = arr.length - 1; i >= 0 ; i--) {
		var word = $.trim(arr[i]);
//		if (points.indexOf(word.charAt(0)) != -1) {
//			word = word.substr(1);
//		}
//		if (points.indexOf(word.charAt(word.length - 1)) != -1) {
//			word = word.substr(0, word.length - 1);
//		}
		if (word != "" && points.indexOf(word) == -1) {
			returnarr.unshift(word);
		}
	}
	return returnarr;
}

(function($)　{
	
	$.fn.wordDeduct = function(read, callback) {
		
		return this.each(function() {
			
			var container = $("<div></div>").addClass("deduct-word-popup-container");
			$(this).append(container);
			
			drawDeduct1();
			
			function drawDeduct1() {
				$(container).empty();
				
				var deductPopup = $("<div></div>").addClass("deduct-word-popup");
				var closeBtn = $("<div><img src='../images/classroom/deduct_close.png' /></div>").addClass("close-button");
				var title = $("<div></div>").addClass("title").text("提示");
				var content = $("<div></div>").addClass("content").text("请您选择扣词模式？");
				var buttons = $("<div></div>").addClass("button-group");
				var autoButton = $("<span></span>").addClass("button left").text("自动扣词");
				var handButton = $("<span></span>").addClass("button").text("手动扣词");
				var modifyButton = $("<span></span>").addClass("modify").text("添加/修改扣词");
				
				$(buttons).append(autoButton);
				$(buttons).append(handButton);
				
				$(deductPopup).append(closeBtn);
				$(deductPopup).append(title);
				$(deductPopup).append(content);
				$(deductPopup).append(buttons);
				$(deductPopup).append(modifyButton);
				
				$(container).append(deductPopup);
				
				$(closeBtn).click(closeThis);
				$(autoButton).click(autoDeduct);
				$(handButton).click(handDeduct);
				$(modifyButton).click(drawDeductList);
			}
			
			
			function drawDeduct2() {
				$(container).empty();
				
				var deductPopup = $("<div></div>").addClass("deduct-word-popup");
				var closeBtn = $("<div><img src='../images/classroom/deduct_close.png' /></div>").addClass("close-button");
				var title = $("<div></div>").addClass("title").text("提示");
				var content = $("<div></div>").addClass("content").text("暂未设置手动扣词内容，是否马上设置？");
				var buttons = $("<div></div>").addClass("button-group");
				var autoButton = $("<span></span>").addClass("button left").text("使用自动扣词");
				var handButton = $("<span></span>").addClass("button").text("设置手动扣词");
				
				$(buttons).append(autoButton);
				$(buttons).append(handButton);
				
				$(deductPopup).append(closeBtn);
				$(deductPopup).append(title);
				$(deductPopup).append(content);
				$(deductPopup).append(buttons);
				
				$(container).append(deductPopup);
				
				$(closeBtn).click(closeThis);
				$(autoButton).click(autoDeduct);
				$(handButton).click(drawDeductList);
			}
		
			function drawDeductList() {
				$(container).empty();
				
				var deductPopup = $("<div></div>").addClass("deduct-word-modify-popup");
				var closeBtn = $("<div><img src='../images/classroom/deduct_close.png' /></div>").addClass("close-button");
				var title = $("<div></div>").addClass("title").text("勾选单词选择扣词内容");
				var deductDiv = $("<div></div>").addClass("deduct-container");
				var deductSaveBtn = $("<div></div>").addClass("deduct-save-btn").text("保存扣词内容");
				
				var deductTitle = $("<div></div>").addClass("deduct-title");
				deductTitle.append($("<div class='title-left'>句子</div>"));
				deductTitle.append($("<div class='title-right'>勾选重点单词</div>"));
				var deductContent = $("<div></div>").addClass("deduct-content");
				var buckleWordsList = $("<table cellspacing='0' cellpadding='0'></table>");
				deductContent.append(buckleWordsList);
				$(deductDiv).append(deductTitle);
				$(deductDiv).append(deductContent);
				
				for (var i = 0; i < read.sentences.length; i++) {
					var sentence = read.sentences[i];
					var tr = $("<tr></tr>").attr("sid", sentence.sid);
					var td1 = $("<td></td>").addClass("li-left").text(sentence.text);
					var td2 = $("<td></td>").addClass("li-right");
					var imps = read.hasDeduct ? sentence.buckleWord : sentence.impWord;
					var allwords = sentence.text.split(" ");
					allwords = cleanText(allwords);
					var impwords = imps.split(" ");
					for (var j = 0; j < allwords.length; j++) {
						var label = $("<label></label>");
						if (impwords.indexOf(allwords[j]) != -1) {
							label.append($("<input type='checkbox' name='words' checked='checked' />"));
						} else {
							label.append($("<input type='checkbox' name='words' />"));
						}
						label.append($("<span></span>").text(allwords[j]));
						td2.append(label);
					}
					
					tr.append(td1);
					tr.append(td2);
					buckleWordsList.append(tr);
				}
				
				
				$(deductPopup).append(closeBtn);
				$(deductPopup).append(title);
				$(deductPopup).append(deductDiv);
				$(deductPopup).append(deductSaveBtn);
				
				$(container).append(deductPopup);
				
				$(closeBtn).click(closeThis);
				$(deductSaveBtn).click(saveDeductWords);
			}
			
			function closeThis() {
				$(container).remove();
			}
			
			function autoDeduct() {
				callback("auto");
				closeThis();
			}
			function handDeduct() {
				if (read.hasDeduct) {
					callback("hand");
					closeThis();
				} else {
					drawDeduct2();
				}
			}
			
			function saveDeductWords() {
				var impwords = getImpwords();
				if (!arivoc_course.online) {
					writeFileToString(read.offlineRoot + "\\buckle.json", JSON.stringify({isBuckle: 1, sentence: impwords}));
					callback(impwords);
					closeThis();
					return;
				}
				$.ajax({
					url: arivoc_course_save_url + "?aaa="+Math.random(),
					type: "get",
					contentType: "application/jsonp; charset=utf-8",
					dataType: "jsonp",
					jsonp: "callback",
					jsonpCallback: "saveBuckleBack",
					data: {
						lessId: read.lessonId,
						wordsMessage : getWordsMessage(impwords)
					},
					success: function(returndata) {
						var result = returndata.result;
						if (result == 0) {
							callback(impwords);
							closeThis();
						} else {
							callback("auto");
							closeThis();
						}
					},
					error: function () {
						callback("auto");
						closeThis();
					}
				});
			}
			
			function getImpwords() {
				var impwords = new Array();
				$(".deduct-word-modify-popup table tr").each(function(i) {
					var impObj = new Object();
					impObj.sid = $(this).attr("sid");
					impObj.impWord = "";
					$(this).find("input:checked").each(function() {
						impObj.impWord += ($(this).siblings("span").text() + " ");
					});
					impwords.push(impObj);
				});
				return impwords;
			}
			
			function getWordsMessage(imps) {
				var message = "";
				for (var i = 0; i < imps.length; i++) {
					if ($.trim(imps[i].impWord).length == 0) {
						continue;
					}
					message += (imps[i].sid + "@@");
					message += imps[i].impWord.replace(/ /g, "@")
					message += "&";
				}
				return message;
			}
		});
		
		
	}
	
})(jQuery);
